<?php
/* --------------------------------------------------------------
	CleverReachRestRequest.inc.php 2016-03-15
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2015 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

class CleverReachRestRequest extends RestRequest
{
	protected $configStorage;

	public function __construct($method, $url, $data = null)
	{
		$this->configStorage = MainFactory::create_object('CleverReachConfigurationStorage');
		$token = $this->getToken();
		$headers = array(
				'Content-Type: application/json',
				'X-ACCESS-TOKEN: ' . $token,
				'Expect:',
			);
		$this->setMethod($method);
		if(substr($url, 0, 8) != 'https://')
		{
			$url = $this->configStorage->get('service_base_url').$url;
		}
		$this->setURL($url);
		$this->setData($data);
		$this->setHeaders($headers);
	}

	public function setData($data)
	{
		if(is_array($data))
		{
			require_once DIR_FS_CATALOG.'gm/classes/JSON.php';
			$jsonService = new Services_JSON();
			$data = $jsonService->encodeUnsafe($data);
		}
		return parent::setData($data);
	}

	protected function getToken()
	{
		$accessToken = $this->configStorage->get('oauth/access_token1') . $this->configStorage->get('oauth/access_token2');
		$expiresAt = $this->configStorage->get('oauth/expires_at');
		if(empty($accessToken))
		{
			throw new Exception('unauthorized - no access token');
		}
		if($expiresAt <= time())
		{
			// refresh token
		}
		return $accessToken;
	}
}
