<?php
/* --------------------------------------------------------------
	CleverReachNewsletterMailSender.inc.php 2016-04-08
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2015 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

class CleverReachNewsletterMailSender
{
	public function sendNewsletterEmail($order_email)
	{
		require_once DIR_FS_INC . 'xtc_random_charcode.inc.php';
		$vlcode      = xtc_random_charcode(32);
		$mailBody    = $this->_getNewsletterEmailBody($order_email, $vlcode);

		if(isset($_SESSION['customer_id']))
		{
			$customers_id        = $_SESSION['customer_id'];
			$customers_status    = $_SESSION['customers_status']['customers_status_id'];
			$customers_firstname = $_SESSION['customer_first_name'];
			$customers_lastname  = $_SESSION['customer_last_name'];
		}
		else
		{
			$check_customer_mail_query = xtc_db_query("select customers_id, customers_status, customers_firstname, customers_lastname, customers_email_address from ".TABLE_CUSTOMERS." where customers_email_address = '".xtc_db_input($order_email)."'");
			if(!xtc_db_num_rows($check_customer_mail_query)) {
				$customers_id        = '0';
				$customers_status    = '1';
				$customers_firstname = TEXT_CUSTOMER_GUEST;
				$customers_lastname  = '';
			}
			else
			{
				$check_customer      = xtc_db_fetch_array($check_customer_mail_query);
				$customers_id        = $check_customer['customers_id'];
				$customers_status    = $check_customer['customers_status'];
				$customers_firstname = $check_customer['customers_firstname'];
				$customers_lastname  = $check_customer['customers_lastname'];
			}
		}

		$sql_data_array = array(
			'customers_email_address' => xtc_db_input($order_email),
			'customers_id'            => xtc_db_input($customers_id),
			'customers_status'        => xtc_db_input($customers_status),
			'customers_firstname'     => xtc_db_input($customers_firstname),
			'customers_lastname'      => xtc_db_input($customers_lastname),
			'mail_status'             => '0',
			'mail_key'                => xtc_db_input($vlcode),
			'date_added'              => 'now()'
		);
		xtc_db_perform(TABLE_NEWSLETTER_RECIPIENTS, $sql_data_array);

		xtc_php_mail(
			EMAIL_SUPPORT_ADDRESS,
			EMAIL_SUPPORT_NAME,
			xtc_db_input($order_email),
			'',
			'',
			EMAIL_SUPPORT_REPLY_ADDRESS,
			EMAIL_SUPPORT_REPLY_ADDRESS_NAME,
			'',
			'',
			TEXT_EMAIL_SUBJECT,
			$mailBody['html_mail'],
			$mailBody['txt_mail']
		);

	}

	protected function _getNewsletterEmailBody($order_email, $vlcode)
	{
		$smarty      = new Smarty();
		$link        = xtc_href_link(FILENAME_NEWSLETTER, 'action=activate&email='.rawurlencode($order_email).'&key='.$vlcode, 'NONSSL');

		$smarty->assign('language',  $_SESSION['language']);
		$smarty->assign('tpl_path',  'templates/'.CURRENT_TEMPLATE.'/');
		$smarty->assign('logo_path', HTTP_SERVER.DIR_WS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/img/');

		$t_customers_query = xtc_db_query("SELECT customers_firstname, customers_lastname, customers_gender FROM " . TABLE_CUSTOMERS . " WHERE customers_email_address = '".xtc_db_input($order_email) . "'");
		if(xtc_db_num_rows($t_customers_query))
		{
			$t_customers_result = xtc_db_fetch_array($t_customers_query);
		}

		$smarty->assign('GENDER', $t_customers_result['customers_gender']);
		$smarty->assign('NAME',   $t_customers_result['customers_firstname'] . ' ' . $t_customers_result['customers_lastname']);
		$smarty->assign('EMAIL',  htmlentities_wrapper($order_email));
		$smarty->assign('LINK',   $link);

		$smarty->caching = false;

		$gm_logo_mail = MainFactory::create_object('GMLogoManager', array("gm_logo_mail"));
		if($gm_logo_mail->logo_use == '1')
		{
			$smarty->assign('gm_logo_mail', $gm_logo_mail->get_logo());
		}

		if(defined('EMAIL_SIGNATURE'))
		{
			$smarty->assign('EMAIL_SIGNATURE_HTML', nl2br(EMAIL_SIGNATURE));
			$smarty->assign('EMAIL_SIGNATURE_TEXT', EMAIL_SIGNATURE);
		}

		$mailBody              = array();
		$mailBody['html_mail'] = fetch_email_template($smarty, 'newsletter_mail');
		$smarty->assign('LINK', str_replace('&amp;', '&', $link));
		$mailBody['txt_mail']  = fetch_email_template($smarty, 'newsletter_mail', 'txt');
		return $mailBody;
	}
}